bt=Sys.time()
library(PLRModels)
library(fda)

etype=2
n=200
p=365

  c=0
  rhop=10
  total=1000
    Yw=NULL
    Tnp=NULL
    beta=c(rep(sqrt(c/p),p))
    m<-2*p-1
    mu=runif(p,2,3)
    rho1<-sort(runif(rhop,0,1))
    rho<-c(rho1,rep(0,p-rhop))
    Gamma<-cbind(diag(rep(rho[1],p)),matrix(0,p,m-p))
    for (i in 2:(p-1))
    {Gamma<-Gamma+cbind(matrix(0,p,i-1),diag(rep(rho[i],p)),matrix(0,p,m-p-i+1))}
    Gamma<-Gamma+cbind(matrix(0,p,m-p),diag(rep(rho[p],p)))
    for(run in 1:total)
    {
      u=sort(runif(n,0,1))   
      #gu=2*u;
      gu=2+sin(2*pi*u)
      z<-matrix(rnorm(n*m,0,1),n,m)
      Xi<-z%*%t(Gamma)+matrix(rep(mu,n),n,p,byrow=T)
      
      eps1=rnorm(n,0,1)
      eps2=rt(n,3)/sqrt(3)
      eps3=rgamma(n,1,1)-1
      eps4=(rlnorm(n)-exp(0.5))/sqrt(exp(1)*(exp(1)-1))
      eps=eps1*(etype==1)+eps2*(etype==2)+eps3*(etype==3)+eps4*(etype==4)
      Y=gu+Xi%*%beta+eps
      
      data=cbind(Y,u)
      h=np.cv(data)$h.opt[2,]
      W=matrix(0,nrow=n,ncol=n)
      X=matrix(0,nrow=n,ncol=p)
      for(i in 1:n)
      {
        Wi0=dnorm((u[i]-u)/h)
        W[i,]=Wi0/sum(Wi0[-i])
        X[i,]=Xi[i,]-W[i,-i]%*%Xi[-i,]
        Yw[i]=Y[i]-W[i,-i]%*%Y[-i]	 
      }
      mX=apply(X,2,mean) 
      mYw=mean(Yw)
      
      #Proposed test
      
      Tij=0
      for(i in 2:n)
      {
        for(j in 1:(i-1))
        {
          deltax=t(X[i,])%*%X[j,]-t(X[i,])%*%mX-t(X[j,])%*%mX+t(mX)%*%mX+1/(2*n)*(t(X[i,])%*%X[i,]-2*t(X[i,])%*%X[j,]+t(X[j,])%*%X[j,])
          deltay=(Yw[i]-mYw)*(Yw[j]-mYw)+1/(2*n)*((Yw[i]-Yw[j])^2)
          Tij1=deltax*deltay
          Tij=Tij+Tij1
        }
      }
      HatTr<-function(bb,ns)
      {   
        nn<-ns*(ns-1)
        bbn<-bb%*%t(bb)
        W1<-sum(diag(t(bb)%*%bb))/ns
        W3<-(sum(bbn)-W1*ns)/nn
        W2<-(sum(bbn^2)-sum(diag(bbn^2)))/nn
        bbn2<-bbn%*%bbn
        diagbb<-rep(diag(bbn),each=ns-1)
        offdiagbb<-as.logical(lower.tri(bbn)+upper.tri(bbn))
        VecOffdiagbb<-matrix(bbn,ns^2,1)[offdiagbb]
        W4<-(sum(bbn2)-sum(diag(bbn2))-2*sum(diagbb*VecOffdiagbb))/(nn*(ns-2))
        W5<-((nn*W3)^2-2*nn*W2-4*nn*(ns-2)*W4)/(nn*(ns-2)*(ns-3))
        trSigma2<-W2-2*W4+W5
        trSigma2
      }
      trSigma<-HatTr(X,n)
      sigma2<-var(Yw-mYw)
      varTn<-2*trSigma*sigma2^2/(n*(n-1))          
      Tnp[run]=1/((1-2/n)^2)*(2/(n*(n-1)))*Tij/sqrt(varTn)
 }    
  sum(Tnp>qnorm(0.95))/total
  
par(mfrow=c(1,2))
qqnorm(Tnp)
qqline(Tnp)
Sys.time()-bt
estTnp=density(Tnp)
#plot(seq(-4,4,length=total),dnorm(seq(-4,4,length=total)),ylim=c(min(estTnp$y,dnorm(seq(-4,4,length=total))),max(estTnp$y,dnorm(seq(-4,4,length=total)))),ylab="",xlab="",main=expression(paste(epsilon~"~"~N(0,1))),type="l",lwd=3)
plot(seq(-4,4,length=total),dnorm(seq(-4,4,length=total)),ylim=c(min(estTnp$y,dnorm(seq(-4,4,length=total))),max(estTnp$y,dnorm(seq(-4,4,length=total)))),ylab="",xlab="",main=expression(paste(epsilon~"~"~t(3)/sqrt(3))),type="l",lwd=3)
#plot(seq(-4,4,length=total),dnorm(seq(-4,4,length=total)),ylim=c(min(estTnp$y,dnorm(seq(-4,4,length=total))),max(estTnp$y,dnorm(seq(-4,4,length=total)))),ylab="",xlab="",main=expression(paste(epsilon~"~"~Gamma(1,1)-1)),type="l",lwd=3)
#plot(seq(-4,4,length=total),dnorm(seq(-4,4,length=total)),ylim=c(min(estTnp$y,dnorm(seq(-4,4,length=total))),max(estTnp$y,dnorm(seq(-4,4,length=total)))),ylab="",xlab="",main=expression(paste(epsilon~"~"~frac(lnorm(0,1)-sqrt(e),sqrt(e(e-1))))),type="l",lwd=3)
lines(estTnp,lty=2,lwd=3)


Sys.time()-bt