library(PLRModels)
library(fda)
test<-function(etype,n,p)
{
cc=seq(0,0.01,length=5)
N=length(cc)
rhop=10
total=1000
pv=matrix(0,nrow=N,ncol=4)
pv1=NULL
pv3=NULL
T_mean=NULL
T_var=NULL

for(k in 1:N)
{
  c=cc[k]
  Yw=NULL
  Chi=NULL
  Tnp=NULL
  beta=c(rep(sqrt(c/p),p))
  m<-2*p-1
  mu=runif(p,2,3)
  rho1<-sort(runif(rhop,0,1))
  rho<-c(rho1,rep(0,p-rhop))
  Gamma<-cbind(diag(rep(rho[1],p)),matrix(0,p,m-p))
  for (i in 2:(p-1))
  {Gamma<-Gamma+cbind(matrix(0,p,i-1),diag(rep(rho[i],p)),matrix(0,p,m-p-i+1))}
  Gamma<-Gamma+cbind(matrix(0,p,m-p),diag(rep(rho[p],p)))
  for(run in 1:total)
  {
    u=sort(runif(n,0,1))   
    #gu=2*u;
    gu=2+sin(2*pi*u)
    z<-matrix(rnorm(n*m,0,1),n,m)
    Xi<-z%*%t(Gamma)+matrix(rep(mu,n),n,p,byrow=T)

    eps1=rnorm(n,0,1)
    eps2=rt(n,3)/sqrt(3)
    eps3=rgamma(n,1,1)-1
    eps4=(rlnorm(n)-exp(0.5))/sqrt(exp(1)*(exp(1)-1))
    eps=eps1*(etype==1)+eps2*(etype==2)+eps3*(etype==3)+eps4*(etype==4)
    Y=gu+Xi%*%beta+eps
    
    xfbasis=create.fourier.basis(c(0,1),p)
    xfd=fd(coef=t(Xi),basisobj=xfbasis)  
    xpca=pca.fd(xfd,nharm=p)
    X2=inprod(xfd,xpca$harmonics)
    pc=cumsum(xpca$values)/sum(xpca$values)
    phat=sum(pc<0.95)
    Xp=X2[,1:phat]
    
    data=cbind(Y,u)
    h=np.cv(data)$h.opt[2,]
    W=matrix(0,nrow=n,ncol=n)
    X=matrix(0,nrow=n,ncol=p)
    for(i in 1:n)
    {
      Wi0=dnorm((u[i]-u)/h)
      W[i,]=Wi0/sum(Wi0[-i])
      X[i,]=Xi[i,]-W[i,-i]%*%Xi[-i,]
      Yw[i]=Y[i]-W[i,-i]%*%Y[-i]	 
    }
    mX=apply(X,2,mean) 
    mYw=mean(Yw)
    
    #Proposed test
    
    Tij=0
    for(i in 2:n)
    {
      for(j in 1:(i-1))
      {
        deltax=t(X[i,])%*%X[j,]-t(X[i,])%*%mX-t(X[j,])%*%mX+t(mX)%*%mX+1/(2*n)*(t(X[i,])%*%X[i,]-2*t(X[i,])%*%X[j,]+t(X[j,])%*%X[j,])
        deltay=(Yw[i]-mYw)*(Yw[j]-mYw)+1/(2*n)*((Yw[i]-Yw[j])^2)
        Tij1=deltax*deltay
        Tij=Tij+Tij1
      }
    }
    HatTr<-function(bb,ns)
    {   
    nn<-ns*(ns-1)
    bbn<-bb%*%t(bb)
    W1<-sum(diag(t(bb)%*%bb))/ns
    W3<-(sum(bbn)-W1*ns)/nn
    W2<-(sum(bbn^2)-sum(diag(bbn^2)))/nn
    bbn2<-bbn%*%bbn
    diagbb<-rep(diag(bbn),each=ns-1)
    offdiagbb<-as.logical(lower.tri(bbn)+upper.tri(bbn))
    VecOffdiagbb<-matrix(bbn,ns^2,1)[offdiagbb]
    W4<-(sum(bbn2)-sum(diag(bbn2))-2*sum(diagbb*VecOffdiagbb))/(nn*(ns-2))
    W5<-((nn*W3)^2-2*nn*W2-4*nn*(ns-2)*W4)/(nn*(ns-2)*(ns-3))
    trSigma2<-W2-2*W4+W5
    trSigma2
    }
    trSigma<-HatTr(X,n)
    sigma2<-var(Yw-mYw)
    varTn<-2*trSigma*sigma2^2/(n*(n-1))          
    Tnp[run]=1/((1-2/n)^2)*(2/(n*(n-1)))*Tij/sqrt(varTn)
    
    #Chi test
    
    Wx=(diag(n)-W)%*%Xp
    Wy=(diag(n)-W)%*%Y
    betahat=solve(t(Wx)%*%Wx)%*%t(Wx)%*%Wy
    sigma21=t(Wy-Wx%*%betahat)%*%(Wy-Wx%*%betahat)/n
    Chi[run]=sigma21^(-1)*t(betahat)%*%t(Wx)%*%Wx%*%(betahat)
    if(Chi[run]>qchisq(0.95,phat))
      pv1[run]=1
    else
      pv1[run]=0
    if(Chi[run]>qchisq(0.9,phat))
      pv3[run]=1
    else
      pv3[run]=0
    #cat(h,Tnp[run],Chi[run],"\n")
  }
  T_mean[k]=mean(Tnp)
  T_var[k]=var(Tnp)
  pv[k,]=c(sum(pv1)/total,sum(Tnp>qnorm(0.95))/total,sum(pv3)/total,sum(Tnp>qnorm(0.9))/total)
  cat(pv[k,],"\n")
}  
pv
}
bt=Sys.time()
RES=matrix(0,nrow=5,ncol=16)
RES[,1:4]=test(1,50,11)
RES[,5:8]=test(2,50,11)
RES[,9:12]=test(3,50,11)
RES[,13:16]=test(4,50,11)
RES
RES1=matrix(0,nrow=5,ncol=16)
RES1[,1:4]=test(1,100,11)
RES1[,5:8]=test(2,100,11)
RES1[,9:12]=test(3,100,11)
RES1[,13:16]=test(4,100,11)
RES1
RES2=matrix(0,nrow=5,ncol=16)
RES2[,1:4]=test(1,100,49)
RES2[,5:8]=test(2,100,49)
RES2[,9:12]=test(3,100,49)
RES2[,13:16]=test(4,100,49)
RES2
Sys.time()-bt

