bt=Sys.time()
library(PLRModels)
rhop=10
N=10
total=1000
pn=matrix(c(201,100,201,200,365,200),nrow=3,ncol=2,byrow=T)
pv1=matrix(0,nrow=3,ncol=N)
for(ii in 1:3)
{
  set.seed(11111)
  p=pn[ii,1]
  n=pn[ii,2]
  cc=seq(0,0.05,length=N)
  for(kk in 1:N)
  { 
    set.seed(11111)
    Tnp=NULL
    c=cc[kk]
    beta=c(rep(sqrt(c/p),p))
    X=matrix(0,nrow=n,ncol=p)
    Yw=NULL
    m<-2*p-1
    mu=runif(p,2,3)
    #mu=rep(0,p)
    rho1<-sort(runif(rhop,0,1))
    rho<-c(rho1,rep(0,p-rhop))
    Gamma<-cbind(diag(rep(rho[1],p)),matrix(0,p,m-p))
    for (i in 2:(p-1))
    {Gamma<-Gamma+cbind(matrix(0,p,i-1),diag(rep(rho[i],p)),matrix(0,p,m-p-i+1))}
    Gamma<-Gamma+cbind(matrix(0,p,m-p),diag(rep(rho[p],p)))
    
    for(run in 1:total)
    {
      u=sort(runif(n,0,1))   
      #gu=2*u;
      gu=2+sin(2*pi*u)
      
      z<-matrix(rnorm(n*m,0,1),n,m)
      Xi<-z%*%t(Gamma)+matrix(rep(mu,n),n,p,byrow=T)
      #eps=rnorm(n)
      #eps=rt(n,3)/sqrt(3)
      #eps=rgamma(n,1,1)-1
      eps=(rlnorm(n)-exp(0.5))/sqrt(exp(1)*(exp(1)-1)) 
      Y=gu+Xi%*%beta+eps
      
      data=cbind(Y,u)
      h=np.cv(data)$h.opt[2,]
      W=matrix(0,nrow=n,ncol=n)
      for(i in 1:n)
      {
        Wi0=dnorm((u[i]-u)/h)
        W[i,]=Wi0/sum(Wi0[-i])
        X[i,]=Xi[i,]-W[i,-i]%*%Xi[-i,]
        Yw[i]=Y[i]-W[i,-i]%*%Y[-i]	 
      }
      mX=apply(X,2,mean) 
      mYw=mean(Yw)
      Tij=0
      for(i in 2:n)
      {
        for(j in 1:(i-1))
        {
          deltax=t(X[i,])%*%X[j,]-t(X[i,])%*%mX-t(X[j,])%*%mX+t(mX)%*%mX+1/(2*n)*(t(X[i,])%*%X[i,]-2*t(X[i,])%*%X[j,]+t(X[j,])%*%X[j,])
          deltay=(Yw[i]-mYw)*(Yw[j]-mYw)+1/(2*n)*((Yw[i]-Yw[j])^2)
          Tij1=deltax*deltay
          Tij=Tij+Tij1
        }
      }
      HatTr<-function(bb,ns)
      {   nn<-ns*(ns-1)
      bbn<-bb%*%t(bb)
      W1<-sum(diag(t(bb)%*%bb))/ns
      W3<-(sum(bbn)-W1*ns)/nn
      W2<-(sum(bbn^2)-sum(diag(bbn^2)))/nn
      bbn2<-bbn%*%bbn
      diagbb<-rep(diag(bbn),each=ns-1)
      offdiagbb<-as.logical(lower.tri(bbn)+upper.tri(bbn))
      VecOffdiagbb<-matrix(bbn,ns^2,1)[offdiagbb]
      W4<-(sum(bbn2)-sum(diag(bbn2))-2*sum(diagbb*VecOffdiagbb))/(nn*(ns-2))
      W5<-((nn*W3)^2-2*nn*W2-4*nn*(ns-2)*W4)/(nn*(ns-2)*(ns-3))
      trSigma2<-W2-2*W4+W5
      trSigma2
      }
      trSigma<-HatTr(X,n)
      sigma2<-var(Yw-mYw)
      varTn<-2*trSigma*sigma2^2/(n*(n-1))          
      Tnp[run]=1/((1-2/n)^2)*(2/(n*(n-1)))*Tij/sqrt(varTn)                                                     
    }
    pv1[ii,kk]=sum(Tnp>qnorm(0.95,0,1))/total  
  }
}
pv1 

par(mfrow=c(1,1))
#plot(c(seq(0,0.05,length=N)),pv1[2,],lwd=3,xlab=expression(abs(beta)^2),ylab="Estimated power",main=expression(paste(~~~~epsilon~"~"~N(0,1))),type="l")
#plot(c(seq(0,0.05,length=N)),pv1[2,],lwd=3,xlab=expression(abs(beta)^2),ylab="Estimated power",main=expression(paste(~~~~epsilon~"~"~t(3)/sqrt(3))),type="l")
plot(c(seq(0,0.05,length=N)),pv1[2,],lwd=3,xlab=expression(abs(beta)^2),ylab="Estimated power",main=expression(paste(~~~~epsilon~"~"~Gamma(1,1)-1)),type="l")
#plot(c(seq(0,0.05,length=N)),pv1[2,],lwd=3,xlab=expression(abs(beta)^2),ylab="Estimated power",main=expression(paste(~~~~epsilon~"~"~frac(lnorm(0,1)-sqrt(e),sqrt(e(e-1))))),type="l")
lines(c(seq(0,0.05,length=N)),pv1[1,],lty=2,lwd=3)
lines(c(seq(0,0.05,length=N)),pv1[3,],lty=3,lwd=3)
legend("bottomright", legend = c("(n,p)=(100,201)", "(n,p)=(200,201)","(n,p)=(200,365)"),lwd=3,xjust = 1,text.width=strwidth("500000,000,00"), seg.len=2,lty=c(2,1,3),bty="o")
Sys.time()-bt

